' Craig Persiko
' CS 112D Practice Problem 5 Solution
' This program connects with the Access Northwind database, 
' using data-aware controls with a typed dataset.

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ProductsTableAdapter.Fill(Me.NorthwindDataSet.Products)
        Me.CategoriesTableAdapter.Fill(Me.NorthwindDataSet.Categories)
    End Sub

    Private Sub btnPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrevious.Click
        Me.CategoriesBindingSource.MovePrevious()
    End Sub

    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        Me.CategoriesBindingSource.MoveNext()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Me.Validate()
        Me.CategoriesBindingSource.EndEdit()
        Me.ProductsBindingSource.EndEdit()

        Try
            'Now, table by table, in "correct" order
            Dim ChangedTable As DataTable

            ' Deleted rows in child table
            ChangedTable = _
                    NorthwindDataSet.Products.GetChanges(DataRowState.Deleted)
            If Not ChangedTable Is Nothing Then
                ProductsTableAdapter.Update(CType(ChangedTable, pp5_2005.NorthwindDataSet.ProductsDataTable))
            End If

            ' All changed rows in parent table
            Me.CategoriesTableAdapter.Update(Me.NorthwindDataSet.Categories)

            ' Added or modified rows in child table
            ChangedTable = _
                    NorthwindDataSet.Products.GetChanges(DataRowState.Added _
                    Or DataRowState.Modified)
            If Not ChangedTable Is Nothing Then
                ProductsTableAdapter.Update(CType(ChangedTable, pp5_2005.NorthwindDataSet.ProductsDataTable))
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Me.CategoriesBindingSource.AddNew()
    End Sub
End Class
